com.smartgwt.client.util

## Class EventHandler

- java.lang.Object
- - com.smartgwt.client.util.EventHandler

-     public class EventHandler
      extends java.lang.Object

  SmartGWT provides a predictable cross-browser event-handling mechanism for SmartGWT widgets, and the EventHandler class provides various static APIs for retrieving details about events which have occurred.

  Events may be intercepted at the page level using standard GWT methods such as addNativePreviewHandler() on the `com.google.gwt.user.client.Event` class.

  If the event occurred on an enabled widget it is sent to that widget's event handler, if any. This handler can cancel further propagation of the event by returning false. An "enabled" widget is any widget that defines an event handler for one of the supported events.

  The event is "bubbled" up to the widget's parent in the containment hierarchy, if any. Again, the parent's handler for the event can cancel further propagation by calling `event.cancel()`. This step is repeated, with the event "bubbling" up through the containment hierarchy, until a top-level widget is reached or the event is explicitly canceled.

  Where applicable, canceling an event will also typically suppress the native behavior (for example canceling a keypress while focused in a form item may prevent the key character being inserted in the text box).

  SmartGWT libraries will not interfere with native event handling when events occur outside of a target widget. You can therefore have HTML that is not ISC-based on the same page as widget objects that will react to native events as you would expect.

  See Also:
    `PageEvent`, `com.smartgwt.client.util.Page#setEvent`, `com.smartgwt.client.util.Page#clearEvent`

- - ### Constructor Summary

    Constructors
    Constructor and Description
    `EventHandler()`

  - ### Method Summary

    All Methods Static Methods Concrete Methods Deprecated Methods
    Modifier and Type | Method and Description
    --- | ---
    `static java.lang.Boolean` | `altKeyDown()` Return true if the alt (option) key is being held down.
    `static java.lang.Boolean` | `ctrlKeyDown()` Return true if the control key is being held down.
    `static Rectangle` | `getDragRect()` During a drag with dragAppearance of either "target" or "outline", returns the page-relative coordinates of whatever element is being dragged.
    `static Canvas` | `getDragTarget()` Returns the current dragTarget.
    `static Canvas` | `getFocusCanvas()` Method to return the `canvasFocus:true` canvas with current keyboard focus.
    `static java.lang.String` | `getKey()` Return the name of the key for the event passed in.
    `static java.lang.String` | `getKeyEventCharacter()` Return the character for the current key being pressed.
    `static int` | `getKeyEventCharacterValue()` Returns the numeric characterValue reported by the browser.
    `static java.lang.Integer` | `getMouseDownX()` Return the page-relative X (horizontal) coordinate of an event.
    `static java.lang.Integer` | `getMouseDownY()` Return the page-relative Y (vertical) coordinate of an event.
    `static java.lang.Object` | `getNativeDragData()`
    `static com.google.gwt.user.client.Element` | `getNativeMouseTarget()` Returns the natively reported target (or source) DOM element for the current mouse event.
    `static Canvas` | `getTarget()` Return the canvas that is the target of the mouse event.
    `static float` | `getWheelDelta()` Deprecated. in favor of `getWheelDeltaY()`
    `static double` | `getWheelDeltaAsDouble()` Deprecated. in favor of `getWheelDeltaY()`
    `static double` | `getWheelDeltaX()` Horizontal scroll delta reported by a `mouseWheel` event (such as a horizontal swipe on a track-pad).
    `static double` | `getWheelDeltaY()` Applies to `mouseWheel` events only.
    `static int` | `getX()` Return the page-relative X (horizontal) coordinate of an event.
    `static int` | `getY()` Return the page-relative Y (vertical) coordinate of an event.
    `static java.lang.Boolean` | `leftButtonDown()` Returns true if the left mouse button is being pressed.
    `static boolean` | `middleButtonDown()` Returns true if the middle mouse button is being pressed.
    `static java.lang.Boolean` | `rightButtonDown()` Returns true if the right mouse button is being pressed.
    `static void` | `setDragTracker(java.lang.String html)` Set the HTML for the drag tracker that follows the mouse during a drag and drop interaction.
    `static void` | `setDragTracker(java.lang.String html, int newWidth, int newHeight, int offsetX, int offsetY)` Set the HTML for the drag tracker that follows the mouse during a drag and drop interaction.
    `static void` | `setDragTrackerImage(java.lang.String src)` This API may be called to set the native HTML5 drag tracker image.
    `static void` | `setDragTrackerImage(java.lang.String src, int x)`
    `static void` | `setDragTrackerImage(java.lang.String src, int x, int y)` This API may be called to set the native HTML5 drag tracker image.
    `static void` | `setNativeDragData(java.lang.Object data)`
    `static void` | `setNativeDragData(java.lang.Object data, java.lang.String strData)`
    `static java.lang.Boolean` | `shiftKeyDown()` Return true if the shift key is being held down.
    `static java.lang.Boolean` | `targetIsMasked(Canvas target)` Return whether this Canvas is masked by a clickMask (see `Canvas.showClickMask()`).

    - ### Methods inherited from class java.lang.Object

      `clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

- - ### Constructor Detail

    - #### EventHandler

          public EventHandler()

  - ### Method Detail

    - #### altKeyDown

          public static java.lang.Boolean altKeyDown()

      Return true if the alt (option) key is being held down. Note that this is only set reliably for keyboard events.
      Returns:
        true == alt key is down

    - #### ctrlKeyDown

          public static java.lang.Boolean ctrlKeyDown()

      Return true if the control key is being held down. Note that this is only set reliably for keyboard events.
      Returns:
        true == control key is down

    - #### getDragTarget

          public static Canvas getDragTarget()

      Returns the current dragTarget. This is the component on which the drag and drop interaction was initiated. This only returns something meaningful during a drag and drop interaction.
      Returns:
        The dragTarget.
      See Also:
        `Canvas.getDragTarget()`

    - #### getFocusCanvas

          public static Canvas getFocusCanvas()

      Method to return the `canvasFocus:true` canvas with current keyboard focus.
      Returns:
        Current focus canvas

    - #### getKeyEventCharacter

          public static java.lang.String getKeyEventCharacter()

      Return the character for the current key being pressed. Note that this is only set reliably for keyPress events on character keys.
      Returns:
        Character the user entered. May be null for non-character keys.

    - #### getKeyEventCharacterValue

          public static int getKeyEventCharacterValue()

      Returns the numeric characterValue reported by the browser. Only available on keyPress events, and only for character (or ascii control) keys
      Returns:
        Numeric character value reported by the browser (ASCII value of the key pressed)

    - #### getNativeMouseTarget

          public static com.google.gwt.user.client.Element getNativeMouseTarget()

      Returns the natively reported target (or source) DOM element for the current mouse event. NOTE: Smart GWT cannot guarantee that the same element will be reported in all browser/platform configurations for all event types. If you wish to make use of this value, we recommend testing your use case in all target browser configurations.
      Returns:
        native DOM element over which the mouse event occurred

    - #### getTarget

          public static Canvas getTarget()

      Return the canvas that is the target of the mouse event. Returns null if no canvas found.
      Returns:
        event target canvas

    - #### getWheelDelta

          public static float getWheelDelta()

      Deprecated. in favor of `getWheelDeltaY()`
      Applies to `mouseWheel` events only. Returns a numeric value indicating how far the mouse wheel was rotated. This value will be positive if the user scrolled the mousewheel forward or up, or negative if scrolled in the other direction. For a standard wheel-mouse, an increment of 1 relates to the smallest possible rotation of the mouse wheel. For other scrolling devices, such as scroll gestures on a track pad, wheel delta may be reported in finer grained increments (causing this method to return a fractional value).

      Note that behavior for trackpad scroll-gestures may differ by browser, but where separate vertical and horizontal scroll information is available, this method refers to a vertical scroll gesture.

      Developers should also be aware that some browsers and operating systems allow the user to configure the sensitivity of the mouse wheel or trackpad, which may change this value.

      Returns:
        numeric value indicating how far the mouse wheel was rotated.

    - #### getWheelDeltaAsDouble

          public static double getWheelDeltaAsDouble()

      Deprecated. in favor of `getWheelDeltaY()`
      Applies to `mouseWheel` events only. Returns a numeric value indicating how far the mouse wheel was rotated. This value will be positive if the user scrolled the mousewheel forward or up, or negative if scrolled in the other direction. For a standard wheel-mouse, an increment of 1 relates to the smallest possible rotation of the mouse wheel. For other scrolling devices, such as scroll gestures on a track pad, wheel delta may be reported in finer grained increments (causing this method to return a fractional value).

      Note that behavior for trackpad scroll-gestures may differ by browser, but where separate vertical and horizontal scroll information is available, this method refers to a vertical scroll gesture.

      Developers should also be aware that some browsers and operating systems allow the user to configure the sensitivity of the mouse wheel or trackpad, which may change this value.

      Returns:
        numeric value indicating how far the mouse wheel was rotated.

    - #### getWheelDeltaX

          public static double getWheelDeltaX()

      Horizontal scroll delta reported by a `mouseWheel` event (such as a horizontal swipe on a track-pad).

      Returns a numeric value indicating how far the mouse wheel was rotated / the magnitude of the scroll gesture. This value will be positive if the user scrolled the mousewheel to the right, negative if scrolled in the other direction.

      Returns:
        numeric value indicating how far the mouse wheel was rotated.
      See Also:
        `getWheelDeltaY()`

    - #### getWheelDeltaY

          public static double getWheelDeltaY()

      Applies to `mouseWheel` events only. Returns a numeric value indicating how far the mouse wheel was rotated. This value will be positive if the user scrolled the mousewheel forward or up, or negative if scrolled in the other direction. For a standard wheel-mouse, an increment of 1 relates to the smallest possible rotation of the mouse wheel. For other scrolling devices, such as scroll gestures on a track pad, wheel delta may be reported in finer grained increments (causing this method to return a fractional value).

      Note that behavior for trackpad scroll-gestures may differ by browser, but where separate vertical and horizontal scroll information is available, this method refers to a vertical scroll gesture.

      Developers should also be aware that some browsers and operating systems allow the user to configure the sensitivity of the mouse wheel or trackpad, which may change this value.

      Returns:
        numeric value indicating how far the mouse wheel was rotated.
      See Also:
        `getWheelDeltaX()`

    - #### getX

          public static int getX()

      Return the page-relative X (horizontal) coordinate of an event.
      Returns:
        x-coordinate in page coordinate space

    - #### getY

          public static int getY()

      Return the page-relative Y (vertical) coordinate of an event.
      Returns:
        y-coordinate in page coordinate space

    - #### leftButtonDown

          public static java.lang.Boolean leftButtonDown()

      Returns true if the left mouse button is being pressed.
      Returns:
        true == left button is down, false == up
      See Also:
        `middleButtonDown()`, `rightButtonDown()`

    - #### middleButtonDown

          public static boolean middleButtonDown()

      Returns true if the middle mouse button is being pressed.

      Checking whether the middle mouse button is pressed can be used to implement power user shortcuts; however, note that many pointing devices do not have a middle button. Thus, the application should not require the user to press a middle button in order to perform some action.

      Returns:
        true if the middle mouse button is pressed; false otherwise.
      See Also:
        `leftButtonDown()`, `rightButtonDown()`

    - #### rightButtonDown

          public static java.lang.Boolean rightButtonDown()

      Returns true if the right mouse button is being pressed.
      Returns:
        true == right button is down, false == up
      See Also:
        `leftButtonDown()`, `middleButtonDown()`

    - #### setDragTrackerImage

          public static void setDragTrackerImage(java.lang.String src)

      This API may be called to set the native HTML5 drag tracker image. The `x` and `y` parameters may be specified to affect the placement of the drag tracker image relative to the mouse cursor. The size of the drag tracker image is the intrinsic size of the image. Browsers may apply certain visual effects (such as a slight transparency) to this image.

      Can only be called during the `Canvas.dragStart()` event (or methods called during the handling of that event).

      NOTES:

      - Not supported in Opera 12.x or Safari.
      - For best results, this image should be preloaded. Otherwise, the image might not appear for the first drag using this image.
      - This API does not work in Chrome or Firefox on Windows 7 if the "Use visual styles on windows and buttons" setting is turned off.
      Parameters:
        `src` - image source. See `SCImgURL`
      See Also:
        `SCImgURL`

    - #### setDragTrackerImage

          public static void setDragTrackerImage(java.lang.String src,
                                                 int x)

      See Also:
        `setDragTrackerImage(java.lang.String)`

    - #### setDragTrackerImage

          public static void setDragTrackerImage(java.lang.String src,
                                                 int x,
                                                 int y)

      This API may be called to set the native HTML5 drag tracker image. The `x` and `y` parameters may be specified to affect the placement of the drag tracker image relative to the mouse cursor. The size of the drag tracker image is the intrinsic size of the image. Browsers may apply certain visual effects (such as a slight transparency) to this image.

      Can only be called during the `Canvas.dragStart()` event (or methods called during the handling of that event).

      NOTES:

      - Not supported in Opera 12.x or Safari.
      - For best results, this image should be preloaded. Otherwise, the image might not appear for the first drag using this image.
      - This API does not work in Chrome or Firefox on Windows 7 if the "Use visual styles on windows and buttons" setting is turned off.
      Parameters:
        `src` - image source. See `SCImgURL`
        `x` - offset-x from the mouse cursor
        `y` - offset-y from the mouse cursor

    - #### shiftKeyDown

          public static java.lang.Boolean shiftKeyDown()

      Return true if the shift key is being held down. Note that this is only set reliably for keyboard events.
      Returns:
        true == shift key is down

    - #### targetIsMasked

          public static java.lang.Boolean targetIsMasked(Canvas target)

      Return whether this Canvas is masked by a clickMask (see `Canvas.showClickMask()`).
      Parameters:
        `target` - widget to check
      Returns:
        true if masked, false if not masked.

    - #### setDragTracker

          public static void setDragTracker(java.lang.String html)

      Set the HTML for the drag tracker that follows the mouse during a drag and drop interaction.

      Your canvas can use this routine to set the drag tracker to whatever HTML you want like so:

              dragStart : function
           () {        isc.EventHandler.setDragTracker('Your contents here');    }

      Parameters:
        `html` - HTML for the tracker

    - #### setDragTracker

          public static void setDragTracker(java.lang.String html,
                                            int newWidth,
                                            int newHeight,
                                            int offsetX,
                                            int offsetY)

      Set the HTML for the drag tracker that follows the mouse during a drag and drop interaction.

      Your canvas can use this routine to set the drag tracker to whatever HTML you want like so:

              dragStart : function
           () {        isc.EventHandler.setDragTracker('Your contents here');    }

      Parameters:
        `html` - HTML for the tracker
        `newWidth` - new width for the tracker
        `newHeight` - new height for the tracker
        `offsetX` - x-offset for the tracker
        `offsetY` - y-offset for the tracker

    - #### getDragRect

          public static Rectangle getDragRect()

      During a drag with dragAppearance of either "target" or "outline", returns the page-relative coordinates of whatever element is being dragged. Calling this method allows you to write drag and drop logic that works identically even if dragAppearance is subsequently changed.
      Returns:
        lobal (page-relative) coordinates and size of the dragged element, as a 4-element array [left,top,width,height], or null if not dragging

    - #### getMouseDownX

          public static java.lang.Integer getMouseDownX()

      Return the page-relative X (horizontal) coordinate of an event.
      Returns:
        x-coordinate in page coordinate space

    - #### getMouseDownY

          public static java.lang.Integer getMouseDownY()

      Return the page-relative Y (vertical) coordinate of an event.
      Returns:
        y-coordinate in page coordinate space

    - #### getNativeDragData

          public static java.lang.Object getNativeDragData()

    - #### setNativeDragData

          public static void setNativeDragData(java.lang.Object data)

    - #### setNativeDragData

          public static void setNativeDragData(java.lang.Object data,
                                               java.lang.String strData)

    - #### getKey

          public static java.lang.String getKey()

      Return the name of the key for the event passed in. Note that this is only set reliably for keyboard events.

           Strings to identify the various keys on the keyboard.

           For alpha keys, the single (uppercase) character value is used, such as "Q"
           For Numeric keys, the number is used as in a single character string, like "1"
           Function keys are identified as "f1" - "f12"
           Non alpha-numeric character keys (such as the key for "[" / "{") are identified by their unmodified character value (the value obtained by hitting the key without holding shift down), by default - exceptions are listed below.
           Additional key names:
           - Space
           - Tab
           - Enter
           - Escape
           - Backspace
           - Insert
           - Delete
           - Arrow_Up
           - Arrow_Down
           - Arrow_Left
           - Arrow_Right
           - Home
           - End
           - Page_Up
           - Page_Down
           - Shift
           - Ctrl
           - Alt
           [Note: Some keys may not be available for capture on every platform]

      Returns:
        the key name
      See Also:
        `KeyNames`